/*
 * Copyright (c) 2009-2015, Olivier MATZ <zer0@droids-corp.org>
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the University of California, Berkeley nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef UCG_CMDLINE_PARSE_FILE_H_
#define UCG_CMDLINE_PARSE_FILE_H_

#include "ucg_cmdline_parse.h"

/* size of a parsed file */
#define UCG_FILENAME_SIZE UCG_CMDLINE_MAX_TOKEN_SIZE

typedef char ucg_cmdline_filename_t[UCG_FILENAME_SIZE];

#define PARSE_FILE_F_CREATE    0x01 /* file does not necessarilly exist */
#define PARSE_FILE_F_DIRECTORY 0x02 /* must be a directory */
struct ucg_cmdline_token_file_data {
	int flags;
};

struct ucg_cmdline_token_file {
	struct ucg_cmdline_token_hdr hdr;
	struct ucg_cmdline_token_file_data file_data;
};
typedef struct ucg_cmdline_token_file ucg_cmdline_parse_token_file_t;

extern struct ucg_cmdline_token_ops ucg_cmdline_token_file_ops;

#define TOKEN_FILE_INITIALIZER(structure, field, node_flags)	\
{								\
	.hdr = {						\
		.ops = &ucg_cmdline_token_file_ops,		\
		.offset = offsetof(structure, field),		\
	},							\
	.file_data = {						\
		.flags = node_flags,				\
	},							\
}

#endif /* UCG_CMDLINE_PARSE_FILE_H_ */
